#!/usr/bin/perl
#  EmondeProfilMatrice.pl

<<DOC; 
B. Habert
14/10/00

               EmondeProfilMatrice.pl :


Format d'entre : 
Usage : EmondeProfilMatrice.pl -type <individus|traits> -partie_commune <partie commune des noms de fichiers de la matrice traite> [-repartition_plancher <entier positif>][-frequence_plancher <entier positif>][-moyenne_plancher <entier positif>][-ecart_type_plancher <entier positif>][-repartition_plafond <entier positif>][-frequence_plafond <entier positif>][-moyenne_plafond <entier positif>][-ecart_type_plafond <entier positif>]
Il s'agit ici de vraies options qui peuvent tre dans n'importe quel ordre.
Suppose l'existence de fichiers de nom <partie commune des noms de fichiers de la matrice traite> 
     et d'extension .ProfilColonnes et .ChoixTraits si -type a pour valeur traits 
     ou d'extension .ProfilLignes et .ChoixIndividus si -type a pour valeur individus
       Exemple d'appel : 
EmondeProfilMatrice.pl -type traits -partie_commune essai8 -frequence_plancher 5 -frequence_plafond 12


       prend en entre un profil de lignes ou de colonnes de matrice, produit par StatWordByFile2Matrice.pl (FournitProfilColonnesLignesMatrice.pl). 
De la forme pour les traits :

<trait><tabulation><# parties concernes><tabulation><frquence totale><tabulation><moyenne><tabulation><cart type><tabulation><nom engendr><tabulation><numro colonne><tabulation>< garder ou non>
Exemple :
A       4       4584    1146.0  0.0     _aaaaab_        1       O

       et pour les individus :
<individu><tabulation><# parties concernes><tabulation><frquence totale><tabulation><moyenne><tabulation><cart type><tabulation><individu><tabulation>< garder ou non>

Exemple :
jura_speleo1    56      23629   363.5   6808.5  jura_speleo1    N

Format de sortie :
       le profil d'entre avec la dernire colonne modifie (O remplac par N) en fonction des seuils choisis, dans un  fichier d'mondage de suffixe $SuffixeFichierProfilEmonde [.Emondage]. C'est ce fichier d'mondage qui sera utilis par ElimineColonnesLignesDeMatrice.pl.

A faire :

Bugs et problmes :
    . Il n'y a pas de contrle de cohrence sur les valeurs des arguments numriques.

DOC

use Getopt::Long ;
@optl = ("type=s", "partie_commune=s", "repartition_plancher:i", "frequence_plancher:i", "moyenne_plancher:i", "ecart_type_plancher:i", "repartition_plafond:i", "frequence_plafond:i", "moyenne_plafond:i", "ecart_type_plafond:i") ;

$ChaineUsage = "Usage : EmondeProfilMatrice.pl -type <individus|traits> -partie_commune <partie commune des noms de fichiers de la matrice traite> [-repartition_plancher <entier positif>][-frequence_plancher <entier positif>][-moyenne_plancher <entier positif>][-ecart_type_plancher <entier positif>][-repartition_plafond <entier positif>][-frequence_plafond <entier positif>][-moyenne_plafond <entier positif>][-ecart_type_plafond <entier positif>]\nSuppose l'existence de fichiers de nom <partie commune des noms de fichiers de la matrice traite> \n\tet d'extension .ProfilColonnes et .ChoixTraits si -type a pour valeur traits \n\tou d'extension .ProfilLignes et .ChoixIndividus si -type a pour valeur individus\n" ;

die $ChaineUsage unless GetOptions @optl  ;


#$DateCourante                 = `date` ;
$DateCourante                 = localtime ;
$NomFichierJournalMatrice     = "Matrices.Journal" ;
$ValeurPlancherParDefaut   = 0 ;
$ValeurPlafondParDefaut    = 100000 ;

if ($opt_repartition_plancher) {$RepartitionPlancher = $opt_repartition_plancher ; } else {$RepartitionPlancher = $ValeurPlancherParDefaut ; }
if ($opt_frequence_plancher) {$FrequencePlancher = $opt_frequence_plancher ; } else {$FrequencePlancher = $ValeurPlancherParDefaut ; }
if ($opt_moyenne_plancher) {$MoyennePlancher = $opt_moyenne_plancher ; } else {$MoyennePlancher  = $ValeurPlancherParDefaut ; }
if ($opt_ecart_type_plancher) {$EcartTypePlancher  = $opt_ecart_type_plancher ; } else {$EcartTypePlancher = $ValeurPlancherParDefaut ; }
if ($opt_repartition_plafond) {$RepartitionPlafond = $opt_repartition_plafond ; } else {$RepartitionPlafond = $ValeurPlafondParDefaut ; }
if ($opt_frequence_plafond) {$FrequencePlafond = $opt_frequence_plafond; } else {$FrequencePlafond = $ValeurPlafondParDefaut ; }
if ($opt_moyenne_plafond) {$MoyennePlafond = $opt_moyenne_plafond ; } else {$MoyennePlafond = $ValeurPlafondParDefaut ; }
if ($opt_ecart_type_plafond) {$EcartTypePlafond = $opt_ecart_type_plafond ; } else {$EcartTypePlafond = $ValeurPlafondParDefaut ; }

$TypeProfil = $opt_type ; 
$PartieCommuneNomsFichiers  = $opt_partie_commune ; 

$BaliseEntreChoixEtIndividuOuTrait       = "<CHOIX/>" ;
$ChoixPositif                            = "[oO+]" ;
$ChoixNegatif                            = "[Nn-]" ;
$ExtensionProfilIndividus                = ".ProfilLignes" ;
$ExtensionProfilTraits                   = ".ProfilColonnes" ;
$ExtensionChoixIndividus                 = ".ChoixIndividus" ;
$ExtensionChoixTraits                    = ".ChoixTraits" ;
$NomFichierProfil                        = "" ;
$NomFichierChoix                         = "" ;
$AGarder                                 = "O" ;
$ASupprimer                              = "N" ;
$SuffixeFichierProfilEmonde              = ".Emondage" ;
%Item2AGarderOuASupprimer                = () ;

if ($TypeProfil =~ /individus/)
{$NomFichierProfil = $PartieCommuneNomsFichiers . $ExtensionProfilIndividus ; 
 $NomFichierChoix = $PartieCommuneNomsFichiers . $ExtensionChoixIndividus ;
}
elsif ($TypeProfil =~ /traits/)
{$NomFichierProfil = $PartieCommuneNomsFichiers . $ExtensionProfilTraits ; 
 $NomFichierChoix = $PartieCommuneNomsFichiers . $ExtensionChoixTraits ;
}
else
{print "Verification type\n" ; die $ChaineUsage ; }

$NomFichierProfilEmonde                  = $NomFichierProfil . $SuffixeFichierProfilEmonde ;

open(CHOIXITEMS, "<$NomFichierChoix") ;
if ($TypeProfil =~ /individus/)
{LitChoixIndividus() ;
}
elsif ($TypeProfil =~ /traits/)
{LitChoixTraits() ;
}
close(CHOIXITEMS) ;

open(PROFILEMONDEUR, ">$NomFichierProfilEmonde") ;
open(PROFIL, "<$NomFichierProfil") ;
print PROFILEMONDEUR "#Rpartition plancher $RepartitionPlancher  plafond $RepartitionPlafond ; frequence plancher $FrequencePlancher  plafond $FrequencePlafond ; moyenne plancher $MoyennePlancher plafond $MoyennePlafond ; ecart_type plancher $EcartTypePlancher plafond $EcartTypePlafond\n" ;
while ($Ligne = <PROFIL>){
# profil d'individu
#                  ind      repart    freq     moy        e-t        ind      statut
 if ($Ligne =~ /^([^\t]+)\t([^\t]+)\t([^\t]+)\t([^\t]+)\t([^\t]+)\t([^\t]+)\t([^\r\n\t]+)\r?$/
     || 
# profil de variable
#                  trait    repart    freq     moy       e-t        nom     num col   statut
     $Ligne =~ /^([^\t]+)\t([^\t]+)\t([^\t]+)\t([^\t]+)\t([^\t]+)\t([^\t]+\t[^\t]+)\t([^\r\n]+)\r?$/)
   {$Item                       = $1 ;
    $PartiesConcernees          = $2 ;
    $FrequenceTotale            = $3 ;
    $Moyenne                    = $4 ;
    $EcartType                  = $5 ;
    $NomEngendreOptionnellementTabNumCol = $6 ;
    $AGarderOuNon               = $7 ;
    if (exists($Item2AGarderOuASupprimer{$Item}))
    {if ($Item2AGarderOuASupprimer{$Item} eq $AGarder)
     {$StatutFinal = $AGarder ;
     }
     else
     {$StatutFinal = $ASupprimer ;
     }
    }
    else
    {
     if ($PartiesConcernees < $RepartitionPlancher || $PartiesConcernees > $RepartitionPlafond )
     {$StatutFinal = $ASupprimer ; }
#     elsif ($FrequenceTotale < $FrequencePlancher || $FrequenceTotale == 0 || $FrequenceTotale > $FrequencePlafond )
     elsif ($FrequenceTotale < $FrequencePlancher || $FrequenceTotale > $FrequencePlafond )
     {$StatutFinal = $ASupprimer ; }
     elsif ($Moyenne < $MoyennePlancher || $Moyenne > $MoyennePlafond)
     {$StatutFinal = $ASupprimer ; }
     elsif ($EcartType < $EcartTypePlancher || $EcartType > $EcartTypePlafond)
     {$StatutFinal = $ASupprimer ; }
     else
     {$StatutFinal = $AGarder ; }
     }
     print PROFILEMONDEUR "$Item\t$PartiesConcernees\t$FrequenceTotale\t$Moyenne\t$EcartType\t$NomEngendreOptionnellementTabNumCol\t$StatutFinal\n" ;
  }
}
close(PROFIL) ;
close(PROFILEMONDEUR) ;

    print  "EmondeProfilMatrice.pl \n\t\t-type\t\t\t$opt_type\n\t\t-partie_commune\t\t\t$opt_partie_commune \n\t\t-repartition_plancher\t\t\t$opt_repartition_plancher  \n\t\t-frequence_plancher\t\t\t$opt_frequence_plancher  \n\t\t-moyenne_plancher\t\t\t$opt_moyenne_plancher  \n\t\t-ecart_type_plancher\t\t\t$opt_ecart_type_plancher  \n\t\t-repartition_plafond\t\t\t$opt_repartition_plafond  \n\t\t-frequence_plafond\t\t\t$opt_frequence_plafond  \n\t\t-moyenne_plafond\t\t\t$opt_moyenne_plafond\n\t\t-ecart_type_plafond\t\t\t$opt_ecart_type_plafond\n\n" ;
print  "\nFichiers d'entre : $NomFichierProfil et $NomFichierChoix\n\nFichier de sortie : $NomFichierProfilEmonde\n" ;

MetAJourJournalMatrice() ;

######################### Routines ####################################

sub MetAJourJournalMatrice{
    open(JOURNAL, ">>$NomFichierJournalMatrice") ;
    print JOURNAL "\n\n---------------\n$DateCourante\n\n" ;
    print JOURNAL "EmondeProfilMatrice.pl \n\t\t-type\t\t\t$opt_type\n\t\t-partie_commune\t\t\t$opt_partie_commune \n\t\t-repartition_plancher\t\t\t$opt_repartition_plancher  \n\t\t-frequence_plancher\t\t\t$opt_frequence_plancher  \n\t\t-moyenne_plancher\t\t\t$opt_moyenne_plancher  \n\t\t-ecart_type_plancher\t\t\t$opt_ecart_type_plancher  \n\t\t-repartition_plafond\t\t\t$opt_repartition_plafond  \n\t\t-frequence_plafond\t\t\t$opt_frequence_plafond  \n\t\t-moyenne_plafond\t\t\t$opt_moyenne_plafond\n\t\t-ecart_type_plafond\t\t\t$opt_ecart_type_plafond\n\n" ;
    print JOURNAL "\nFichiers d'entre : $NomFichierProfil et $NomFichierChoix\n\nFichier de sortie : $NomFichierProfilEmonde\n\n" ;
    close(JOURNAL) ;
}

sub LitChoixIndividus{
  while ($LigneChoix = <CHOIXITEMS>){
  if ($LigneChoix =~ /^$ChoixPositif$BaliseEntreChoixEtIndividuOuTrait(.+)/)
      {$Individu = $1 ;
       $Item2AGarderOuASupprimer{$Individu} = $AGarder ;
   }
  elsif ($LigneChoix =~ /^$ChoixNegatif$BaliseEntreChoixEtIndividuOuTrait(.+)/)
      {$Individu = $1 ;
       $Item2AGarderOuASupprimer{$Individu} = $ASupprimer ;
   }
 }
}

sub LitChoixTraits{
  while ($LigneChoix = <CHOIXITEMS>){
  if ($LigneChoix =~ /^$ChoixPositif$BaliseEntreChoixEtIndividuOuTrait([^\t]+)\t(.+)/)
      {$Trait = $1 ;
       $Item2AGarderOuASupprimer{$Trait} = $AGarder ;
       print "A garder $Trait\n" ;
   }
  elsif ($LigneChoix =~ /^$ChoixNegatif$BaliseEntreChoixEtIndividuOuTrait([^\t]+)\t(.+)/)
      {$Trait = $1 ;
       $Item2AGarderOuASupprimer{$Trait} = $ASupprimer ;
   }
 }
}
