#!/usr/bin/perl 
#  FournitProfilColonnesLignesMatrice.pl

<<DOC; 
B. Habert
13/10/00

               FournitProfilColonnesLignesMatrice.pl :
FournitProfilColonnesLignesMatrice.pl <partie commune du nom de la matrice produite par LignesNomFichierCouplesFrequenceType2Matrice.pl et de la correspondance nom engendr / trait originel>
Suppose qu'existe un fichier suffix par $SuffixeMatrice et un autre suffix $SuffixeNoms2Traits et de prfixe <partie commune du nom de la matrice produite par LignesNomFichierCouplesFrequenceType2Matrice.pl et de la correspondance nom engendr / trait originel>.
Exemple d'appel :
     FournitProfilColonnesLignesMatrice.pl es8

Format d'entre : 
     Une matrice et un fichier de correspondance nom engendr / trait originel produits par LignesNomFichierCouplesFrequenceType2Matrice.pl lors de l'appel  StatWordByFile2Matrice.pl

Format de sortie :
     Un fichier de suffixe $SuffixeProfilColonnes et un fichier de suffixe $SuffixeProfilLignes. Ils ont pourprfixe la <partie commune du nom de la matrice produite par LignesNomFichierCouplesFrequenceType2Matrice.pl et de la correspondance nom engendr / trait originel>. Ils correspondent respectivement aux profils des colonnes (traits) et des individus.

A faire :

Bugs et problmes :

DOC

if (@ARGV != 1 ) {die "Usage : FournitProfilColonnesLignesMatrice.pl <partie commune du nom de la matrice produite par LignesNomFichierCouplesFrequenceType2Matrice.pl et de la correspondance nom engendr / trait originel>\n" ; }

%Trait2NombrePartiesConcernees                 = () ;
%Trait2FrequenceTotale                         = () ;
%Trait2Moyenne                                 = () ;
%Trait2Variance                                = () ;
%Individu2NombreTraitsConcernes                = () ;
%Individu2FrequenceTotale                      = () ;
%Individu2Moyenne                              = () ;
%Individu2Variance                             = () ;
$NombreIndividus                               = 0 ;
$SuffixeMatrice                                = ".Matrice" ;
$SuffixeNoms2Traits                            = ".Noms2Traits" ;
$NomFichierMatrice                             = $ARGV[0] . $SuffixeMatrice ;
$NomFichierNoms2Traits                         = $ARGV[0] . $SuffixeNoms2Traits ;
$SuffixeProfilLignes                           = ".ProfilLignes" ;
$SuffixeProfilColonnes                         = ".ProfilColonnes" ;
$NomFichierProfilLignes                        = $ARGV[0] . $SuffixeProfilLignes ;
$NomFichierProfilColonnes                      = $ARGV[0] . $SuffixeProfilColonnes ;

open(MATRICE, "<$NomFichierMatrice") ;
LitNomsTraitsEtInitialiseMatrices() ;
MemorisePartiesConcerneesEtFrequenceTotale() ;
close(MATRICE) ;
CalculeMoyennes() ;
CalculeVariance() ;
ImprimeProfilColonnes() ;


######################## Routines ###############################"""

sub CalculeVariance{
  open(MATRICE, "<$NomFichierMatrice") ;
  # Elimination de la ligne des noms engendrs
  $LigneIndividu = <MATRICE> ;
  while ($LigneIndividu = <MATRICE>){
     chop($LigneIndividu) ;
     @ListeIndividu = split(/\t/, $LigneIndividu) ;
     $IndividuCourant = $ListeIndividu[0] ;
     for ($i = 1 ; $i <= $#ListeIndividu ; $i++)
     {$EcartMoyenneOccurrencesTrait = $Trait2Moyenne{$ListeNomsTraits[$i]} - $ListeIndividu[$i] ;
      $Trait2Variance{$ListeNomsTraits[$i]} += $EcartMoyenneOccurrencesTrait**2 ;
      $EcartMoyenneOccurrencesIndividu = $Individu2Moyenne{$IndividuCourant} - $ListeIndividu[$i] ;
      $Individu2Variance{$IndividuCourant} += $EcartMoyenneOccurrencesIndividu**2 ;
      
     }
  } 
  close(MATRICE) ;
}

sub MemorisePartiesConcerneesEtFrequenceTotale{
while ($LigneIndividu = <MATRICE>){
     chop($LigneIndividu) ;
     @ListeIndividu = split(/\t/, $LigneIndividu) ;
     $IndividuCourant = $ListeIndividu[0] ;
     for ($i = 1 ; $i <= $#ListeIndividu ; $i++)
     {if ($ListeIndividu[$i] > 0)
      {$Trait2NombrePartiesConcernees{$ListeNomsTraits[$i]}++ ;
       $Trait2FrequenceTotale{$ListeNomsTraits[$i]} += $ListeIndividu[$i] ;
       $Individu2NombreTraitsConcernes{$IndividuCourant}++ ;
       $Individu2FrequenceTotale{$IndividuCourant} += $ListeIndividu[$i] ;
      }
     }
     $NombreIndividus++ ;
  } 
}

sub CalculeMoyennes{
   $NombreTraits = $#ListeNomsTraits ;
   for ($i = 1 ; $i <= $#ListeNomsTraits ; $i++)
   {$Trait2Moyenne{$ListeNomsTraits[$i]} = 
    $Trait2FrequenceTotale{$ListeNomsTraits[$i]} / $NombreIndividus ;
   }
   while (($NomIndividu, $FrequenceTotaleIndividu) = each(%Individu2FrequenceTotale)){
       $Individu2Moyenne{$NomIndividu} = $FrequenceTotaleIndividu / $NombreTraits ;
   }
}

sub ImprimeProfilColonnes{
 open(NOMS2TRAITS, "<$NomFichierNoms2Traits") ;
 open(COLONNES, ">$NomFichierProfilColonnes") ;
 for ($i = 1 ; $i <= $#ListeNomsTraits ; $i++)
 {$LigneNoms2Traits = <NOMS2TRAITS> ;
  $LigneNoms2Traits =~ /^[^\t]+\t([^\n\r]+)/ ;
  $Trait                 = $1 ;
  $EcartReduitTrait      = sqrt $Trait2Variance{$ListeNomsTraits[$i]} ;
  print COLONNES "$Trait" ;
  print COLONNES "\t$Trait2NombrePartiesConcernees{$ListeNomsTraits[$i]}" ;
  print COLONNES "\t$Trait2FrequenceTotale{$ListeNomsTraits[$i]}" ;
  printf COLONNES "\t%.1f", $Trait2Moyenne{$ListeNomsTraits[$i]} ;
  printf COLONNES "\t%.1f", $EcartReduitTrait ;
  print COLONNES "\t$ListeNomsTraits[$i]\t$i\tO\n" ;

  }
 close(NOMS2TRAITS) ;
 close(COLONNES) ;
 open(LIGNES, ">$NomFichierProfilLignes") ;
 open(MATRICE, "<$NomFichierMatrice") ;
 # Elimination de la ligne des traits
 $LigneIndividu =  <MATRICE> ;
 while ($LigneIndividu =  <MATRICE>){
     $LigneIndividu =~ /^([^\t]+)/ ;
     $NomIndividuCourant       = $1 ;
     $EcartReduitIndividu      = sqrt $Individu2Variance{$NomIndividuCourant} ;
     print LIGNES "$NomIndividuCourant" ;
     print LIGNES "\t$Individu2NombreTraitsConcernes{$NomIndividuCourant}" ;
     print LIGNES "\t$Individu2FrequenceTotale{$NomIndividuCourant}" ;
     printf LIGNES "\t%.1f", $Individu2Moyenne{$NomIndividuCourant} ;
     printf LIGNES "\t%.1f", $EcartReduitIndividu ;
     print LIGNES "\t$NomIndividuCourant\tO\n" ;
 }
 close(MATRICE) ;
 close(LIGNES) ;
}

sub LitNomsTraitsEtInitialiseMatrices{
     $LigneNomsTraits =  <MATRICE> ;
     chop($LigneNomsTraits) ;
     @ListeNomsTraits = split(/\t/, $LigneNomsTraits) ;
     # La 1re colonne, ID, n'est pas prise en considration
     for ($i = 1 ; $i <= $#ListeNomsTraits ; $i++)
     {
      $Trait2NombrePartiesConcernees{$ListeNomsTraits[$i]} = 0 ;
      $Trait2FrequenceTotale{$ListeNomsTraits[$i]} = 0 ;
      $Trait2Moyenne{$ListeNomsTraits[$i]} = 0 ;
#      print "$ListeNomsTraits[$i]\n" ;
  }
 }

