#!/usr/bin/perl
#  LignesNomFichierCouplesFrequenceType2Matrice.pl

<<DOC; 
B. Habert
03/10/00

               LignesNomFichierCouplesFrequenceType2Matrice.pl :


Format d'entre : 
     Des sorties de Index2NomFichierCouplesFrequenceType.pl, des lignes de la forme :
          <nom de partie>{<tabulation><frquence><tabulation><type>}+

Format de sortie :
     1) Une matrice (extension .Matrice) avec sur la premire ligne, aprs ID, les traits remplacs par des noms engendrs de 8 caractres (des identifieurs utilisant les 26 lettres de l'alphabet sur 6 positions, ce qui fait 308 915 776 possibilits, avec un caractre sparateur arbitraire en dbut et un autre en fin, pour faciliter le remplacement systmatique et rendre improbables les conflits de noms).
    Exemple de matrice :
ID	_aaaaab_	_aaaaac_	_aaaaad_	_aaaaae_
jura_speleo1	1146	6	153	1695
mairie_aureilhan1	47	1	0	213

    2) Une trace de la correspondance noms engendrs / traits originels (extension .Noms2Traits) 
    Exemple correspondant :
        _aaaaab_        A       _aaaaac_        ADDRESS _aaaaad_        AREA    _aaaaae_        B

    3) Un programme Perl excutable de remplacement des noms engendrs par les noms de traits originels (extension .ChangeNoms2Traits.pl).
    Exemple correspondant :
#!/usr/bin/perl
#Tue Oct  3 22:27:28 WEST 2000

#Engendr par LignesNomFichierCouplesFrequenceType2Matrice.pl
#pour JuraAureilhan.Matrice et les donnes qui sont calcules  partir de cette matrice

while(<>)
{
s/_aaaaab_/A/g ;
s/_aaaaac_/ADDRESS/g ;
s/_aaaaad_/AREA/g ;
s/_aaaaae_/B/g ;

print ;
}

    4) Un fichier donnant les variables suivies du nom engendr (extension .ChoixTraits) et un fichier donnant les noms des individus (extension .ChoixIndividus). Ces fichiers sont destins  permettre d'indiquer les variables ou les individus  garder ou  liminer de toute faon (ils sont utiliss par ). Une balise en dbut de ligne sert  sparer les choix faits manuellement de l'indication du trait ou de l'individu concern ($BaliseEntreChoixEtIndividuOuTrait, valant pour le moment "<CHOIX/>" ;
).

A faire :

Bugs et problmes :

DOC

if (@ARGV != 1 ) {die "Usage : LignesNomFichierCouplesFrequenceType2Matrice.pl <sorties de Index2NomFichierCouplesFrequenceType.pl concatnes>\n" ; }

$BaliseEntreChoixEtIndividuOuTrait   = "<CHOIX/>" ;
$NomFichierIndexConcatenes           = $ARGV[0] ;
$NomFichierMatrice                   = $ARGV[0] . ".Matrice" ;
$NomFichierChoixTraits               = $ARGV[0] . ".ChoixTraits" ;
$NomFichierChoixIndividus            = $ARGV[0] . ".ChoixIndividus" ;
$NomFichierNoms2Traits               = $ARGV[0] . ".Noms2Traits" ;
$NomFichierChangeurNoms2Traits       = $ARGV[0] . ".ChangeNoms2Traits.pl" ;
%Trait2Trait                         = () ;
$DebugP                              = 0 ;
$CaractereDebutIdentifieur                       = "_" ;
$CaractereFinIdentifieur                         = "_" ;
@ListeLettresIdentifieur                         = ("a", "a", "a", "a", "a", "a") ;
%Lettre2LettreSuivante                           = ("a", "b",    "b", "c",    "c", "d",   "d", "e",   "e", "f",   "f", "g",   "g", "h",   "h", "i",   "i", "j",   "j", "k",   "k", "l",   "l", "m",   "m", "n",   "n", "o",  "o", "p",  "p", "q",   "q", "r",  "r", "s",  "s", "t",   "t", "u",   "u", "v",   "v", "w",    "w", "x",   "x", "y",   "y", "z",   "z", "a") ;
%Trait2NomEngendre                               = () ;

# Reprage de la totalit des traits employs
open(INDEX, "<$NomFichierIndexConcatenes") ;
while ($Ligne = <INDEX>){
  chop($Ligne) ;
  @ListeNomEtCouples = split /\t/, $Ligne ;
  for ($k = 2 ; $k <= $#ListeNomEtCouples ; $k += 2)
  {$Trait2Trait{$ListeNomEtCouples[$k]} = $Trait2Trait{$ListeNomEtCouples[$k]} ;
  }
}
close(INDEX) ;
@ListeGlobaleDesTraits = sort keys %Trait2Trait ;

# Mise au point et impression de la correspondance trait/nom engendr
open(TRAITS, ">$NomFichierNoms2Traits") ;
open(CHOIXTRAITS, ">$NomFichierChoixTraits") ;
for ($k = 0 ; $k <= $#ListeGlobaleDesTraits ; $k++)
{DonneNouvelIdentifieur() ;
 $Trait2NomEngendre{$ListeGlobaleDesTraits[$k]} = $NouvelIdentifieur ;
 print TRAITS "$NouvelIdentifieur\t$ListeGlobaleDesTraits[$k]\n" ;
 print CHOIXTRAITS "$BaliseEntreChoixEtIndividuOuTrait$ListeGlobaleDesTraits[$k]\t$NouvelIdentifieur\n" ;
}
close(TRAITS) ;
close(CHOIXTRAITS) ;

# Impression de la matrice avec sur la premire ligne, aprs ID, les traits engendrs
open(INDEX, "<$NomFichierIndexConcatenes") ;
open(MATRICE, ">$NomFichierMatrice") ;
open(CHOIXINDIVIDUS, ">$NomFichierChoixIndividus") ;
# Impression de la premire ligne de la matrice
print MATRICE "ID" ;
for ($k = 0 ; $k <= $#ListeGlobaleDesTraits ; $k++)
{print MATRICE "\t$Trait2NomEngendre{$ListeGlobaleDesTraits[$k]}" ;
}
print MATRICE "\n" ;
while ($Ligne = <INDEX>){
  %Trait2Frequence             = () ;
  chop($Ligne) ;
  @ListeNomEtCouples = split /\t/, $Ligne ;
  for ($k = 1 ; $k <= $#ListeNomEtCouples ; $k += 2)
  {$Trait2Frequence{$ListeNomEtCouples[$k + 1]} = $ListeNomEtCouples[$k] ;
  }
  if ($DebugP == 1)
  {print $ListeNomEtCouples[0] ;
  }
  print MATRICE $ListeNomEtCouples[0] ;
  print CHOIXINDIVIDUS "$BaliseEntreChoixEtIndividuOuTrait$ListeNomEtCouples[0]\n" ;
  for ($k = 0 ; $k <= $#ListeGlobaleDesTraits ; $k++)
  {if (exists($Trait2Frequence{$ListeGlobaleDesTraits[$k]}))
   {if ($DebugP == 1)
     {print "\t$Trait2Frequence{$ListeGlobaleDesTraits[$k]}\t$ListeGlobaleDesTraits[$k]" ;
    } 
    print MATRICE "\t$Trait2Frequence{$ListeGlobaleDesTraits[$k]}" ;
   }
   else
   {print MATRICE "\t0" ;
   }
  }
  if ($DebugP == 1)
  {print "\n" ;
  }
  print MATRICE "\n" ;
}
close(INDEX) ;
close(MATRICE) ;
close(CHOIXINDIVIDUS) ;

# Impression du rcriveur de noms engendrs en traits originels, rendu excutable
open(CHANGEUR, ">$NomFichierChangeurNoms2Traits") ;
$Date = `date` ;
print CHANGEUR "#!/usr/bin/perl\n#$Date\n#Engendr par LignesNomFichierCouplesFrequenceType2Matrice.pl\n#pour $NomFichierMatrice et les donnes qui sont calcules  partir de cette matrice\n\nwhile(<>)\n{\n" ;
foreach $TraitCourant (sort keys %Trait2NomEngendre)
{print CHANGEUR "s/$Trait2NomEngendre{$TraitCourant}/$TraitCourant/g ;\n" ;
}
print CHANGEUR "\nprint ;\n}\n\n" ;
close(CHANGEUR) ;
`chmod a+x $NomFichierChangeurNoms2Traits` ;

######### Engendrement d'identificateurs arbitraires ############

sub ZOuNonEn0{
if ($ListeLettresIdentifieur[0] eq "z")
   {die "Nombre maximal d'identifieurs engendrables atteint\n" ;
   }
   else
   {$ListeLettresIdentifieur[0] = $Lettre2LettreSuivante{$ListeLettresIdentifieur[0]} ;
   }
}

sub ZOuNonEn1{
if ($ListeLettresIdentifieur[1] eq "z")
   {ZOuNonEn0() ;           
   } # fin 1
  $ListeLettresIdentifieur[1] = $Lettre2LettreSuivante{$ListeLettresIdentifieur[1]} ;
}

sub ZOuNonEn2{
  if ($ListeLettresIdentifieur[2] eq "z")
   {ZOuNonEn1() ;
   } # fin 2
  $ListeLettresIdentifieur[2] = $Lettre2LettreSuivante{$ListeLettresIdentifieur[2]} ;
}

sub ZOuNonEn3{
 if ($ListeLettresIdentifieur[3] eq "z")
    {ZOuNonEn2() ;
    } # fin 3
  $ListeLettresIdentifieur[3] = $Lettre2LettreSuivante{$ListeLettresIdentifieur[3]} ;
}

sub ZOuNonEn4{
  if ($ListeLettresIdentifieur[4] eq "z")
     {ZOuNonEn3 ;
     } # fin 4
   $ListeLettresIdentifieur[4] = $Lettre2LettreSuivante{$ListeLettresIdentifieur[4]} ;
}


sub DonneNouvelIdentifieur{
  if ($ListeLettresIdentifieur[5] eq "z")
   {ZOuNonEn4 ;
   }
  $ListeLettresIdentifieur[5] = $Lettre2LettreSuivante{$ListeLettresIdentifieur[5]} ;
  $NouvelIdentifieur = $CaractereFinIdentifieur . join('', @ListeLettresIdentifieur) . $CaractereFinIdentifieur ;
}

