#!/usr/bin/perl
#  StatWordByFile2ChoixTraitsPourStatWordByFile2Matrice.pl

<<DOC; 
B. Habert
03/01/01

               StatWordByFile2ChoixTraitsPourStatWordByFile2Matrice.pl :


Format d'entre : 
     StatWordByFile2ChoixTraitsPourStatWordByFile2Matrice.pl -segmentation page|site [-all O|o] [-words O|o] [-tags O|o] [-elts O|o] [-attrs O|o] [-attrvalues O|o] -entree <sorties StatWordByFile> -prefixe_sortie <prfixe du fichier rsultat> [-tri frequence|alphabetique]
 
 Le format d'entre est aussi proche que possible de celui de StatWordByFile2Matrice.pl. Trois arguments obligatoires (-segmentation, -entree, -prefixe_sortie). On peut se concentrer sur une partie seulement des traits grce au jeu des options.

 Attention : -prefixe_sortie et non -prefixe_sorties (contrairement  StatWordByFile2Matrice.pl). L'obligation de donner un prfixe de sortie correspond  la volont de pouvoir constituer pour une matrice donne plusieurs fichiers de choix de traits. 

Format de sortie :
     Un fichier de choix o chaque ligne est de la forme :
<CHOIX/><trait>\t<frquence>

     Les lignes, par dfaut (ou avec l'option (-tri frequence), sont tries par <frquence> dcroissante d'occurrence des traits, pour faciliter les choix. On peut aussi demander un tri par ordre alphabtique des traits (-tri alphabetique).

     Ce fichier a pour prfixe la valeur donne  -prefixe_sortie et pour extension $ExtensionChoixTraits (".ChoixTraitsPourStatWordByFile2Matrice").

     Ce fichier sera modifi  la main pour tre donn en argument  StatWordByFile2Matrice.pl. Les traits que l'on voudra conserver devront comporter O, o ou + en tout dbut de ligne (avant <CHOIX/>).

     Les oprations faites sont notes dans "Matrices.Journal".

A faire :
     Fournir la moyenne et l'cart-type pour chaque trait.


Bugs et problmes :

DOC


use Getopt::Long ;

$ChaineUsage = "Usage : StatWordByFile2ChoixTraitsPourStatWordByFile2Matrice.pl -segmentation page|site [-all O|o] [-words O|o] [-tags O|o] [-elts O|o] [-attrs O|o] [-attrvalues O|o] -entree <sorties StatWordByFile> -prefixe_sortie <prfixe du fichier rsultat> [-tri frequence|alphabetique]\n" ;


@optl = ("segmentation=s", "all:s", "words:s", "tags:s", "elts:s", "attrs:s", "attrvalues:s", "entree=s", "prefixe_sortie=s", "tri:s") ;

die $ChaineUsage  unless GetOptions @optl  ;


$BaliseEntreChoixEtIndividuOuTrait       = "<CHOIX/>" ;
$ExtensionChoixTraits                    = ".ChoixTraitsPourStatWordByFile2Matrice" ;
#$DateCourante                 = `date` ;
$DateCourante                 = localtime ;
$NomFichierJournalMatrice     = "Matrices.Journal" ;
$NomFichierStatByFile         = $opt_entree || die $ChaineUsage  ;
$SegmentationChoisie          = $opt_segmentation || die $ChaineUsage ;
$PrefixeSortie                = $opt_prefixe_sortie || die $ChaineUsage ;
$ResultatsMots      = 0 ;
$ResultatsElts      = 0 ;
$ResultatsAttr      = 0 ;
$ResultatsAttrValue = 0 ;


if ($SegmentationChoisie eq "page") 
   {$PartieEgaleSite = 0 ;
   }
elsif ($SegmentationChoisie eq "site") 
   {$PartieEgaleSite = 1 ;
   }
else
   {print STDERR "$SegmentationChoisie Mauvaise valeur d'option\n" ; die $ChaineUsage ; }

if ($opt_tri)
{if ($opt_tri eq "frequence")
 {$TriParFrequence = 1 ;
 }
 elsif ($opt_tri eq "alphabetique")
 {$TriParFrequence = 0 ;
 }
 else
 {print STDERR "$opt_tri  Mauvaise valeur d'option\n" ; die $ChaineUsage ; }
}
else
 {$TriParFrequence = 1 ;
 }


if ($opt_all)
{if ($opt_all =~ /$OptionChoisie/)
 {$ResultatsMots      = 1 ;
  $ResultatsElts      = 1 ;
  $ResultatsAttr      = 1 ;
  $ResultatsAttrValue = 1 ;

 }
 else 
 {print STDERR "$opt_all Mauvaise valeur d'option\n" ; die $ChaineUsage ; 
 }
}
if ($opt_words)
{if ($opt_words =~ /$OptionChoisie/)
 {$ResultatsMots      = 1 ;
 }
 else 
 {print STDERR "$opt_words Mauvaise valeur d'option\n" ; die $ChaineUsage ; 
 }
}
if ($opt_tags)
{if ($opt_tags =~ /$OptionChoisie/)
 {$ResultatsElts      = 1 ;
  $ResultatsAttr      = 1 ;
  $ResultatsAttrValue = 1 ;

 }
 else 
 {print STDERR "$opt_tags Mauvaise valeur d'option\n" ; die $ChaineUsage ; 
 }
}
if ($opt_elts)
{if ($opt_elts =~ /$OptionChoisie/)
 {$ResultatsElts      = 1 ;
 }
 else 
 {print STDERR "$opt_eltsMauvaise valeur d'option\n" ; die $ChaineUsage ; 
 }
}
if ($opt_attrs)
{if ($opt_attrs =~ /$OptionChoisie/)
 {$ResultatsAttr      = 1 ;
 }
 else 
 {print STDERR "$opt_attrs Mauvaise valeur d'option\n" ; die $ChaineUsage ; 
 }
}
if ($opt_attrvalues)
{if ($opt_attrvalues =~ /$OptionChoisie/)
 {$ResultatsAttrValue = 1 ;
 }
 else 
 {print STDERR "$opt_attrvalues Mauvaise valeur d'option\n" ; die $ChaineUsage ; 
 }
}

$NomFichierChoixTraitsPourStatWordByFile2Matrice = $PrefixeSortie . $ExtensionChoixTraits ;
%Trait2Frequence                                 = () ;
$NumeroBilanPartiel                              = 0 ;
$AncienNomSite                                   = "" ;                 
$AncienNomPage                                   = "" ;      
$NomSite                                         = "" ;                 
$NomPage                                         = "" ;      
$PartieEgaleSite                                 = 1  ;
$NumeroPartieTag                                 = 0 ;


open(STATBYFILE, "<$NomFichierStatByFile") ;
while ($Ligne = <STATBYFILE>){
  if ($Ligne =~ /^<WORDS>/)
  {if ($ResultatsMots == 0)
   {SauteResultatsMots() ;
   }
  }
  elsif ($Ligne =~ /^<TAGS>/)
  {if ($ResultatsElts == 0 && $ResultatsAttr == 0 && $ResultatsAttrValue == 0)
   {SauteResultatsTags() ;
   }
  }
  elsif ($Ligne =~ /^<ELEMENTS>/ && $ResultatsElts == 0)
   {SauteResultatsELEMENTS() ;
   }
  elsif ($Ligne =~ /^<ELEMENTS_ATTR>/ && $ResultatsAttr == 0)
   {SauteResultatsELEMENTS_ATTR() ;
   }
  elsif ($Ligne =~ /^<ELEMENTS_ATTRVALUE>/ && $ResultatsAttrValue == 0)
   {SauteResultatsELEMENTS_ATTRVALUE() ;
   }
  elsif ($Ligne =~ /^<SITE>(.+)<\/SITE>/)
  {$AncienNomSite       = $NomSite ;
   $NomSite             = $1 ;
  }
  elsif ($Ligne =~ /^<PAGE>(.+)<\/PAGE>/)
  {$AncienNomPage       = $NomPage ;
   $NomPage             = $1 ;

   print $Ligne ;
   print "$NomSite\t$NomPage\n" ;
   $NumeroBilanPartiel++ ;
  }
  elsif ($Ligne =~ /^<ITEM>(.+)<\/ITEM><FRQ>(\d+)<\/FRQ>/)
  {$Trait          = $1 ;
   $Frequence      = $2 ;
   if (exists $Trait2Frequence{$Trait})
   {$Trait2Frequence{$Trait} += $Frequence ;
   }
   else
   {$Trait2Frequence{$Trait} = $Frequence ;
   }
  }
}
close(STATBYFILE) ;
 
ImprimeTrait2Frequence() ;

 print STDERR "\nFichier de choix de traits pour StatWordByFile2Matrice.pl : $NomFichierChoixTraitsPourStatWordByFile2Matrice\n\nSi l'on veut laguer a priori la matrice issue de $opt_entree :\n1) Modifier  la main $NomFichierChoixTraitsPourStatWordByFile2Matrice en ajoutant en dbut de ligne O, o ou + devant les traits que l'on veut garder \n2) Appeler StatWordByFile2Matrice.pl avec les options souhaites pour les traits\n\tStatWordByFile2Matrice.pl -segmentation $opt_segmentation <options pour les trits> -entree $opt_entree -prefixe_sorties <prfixe sorties> -choix_traits $NomFichierChoixTraitsPourStatWordByFile2Matrice\n\n\n" ;

MetAJourJournalMatrice() ;

    

################### Routines #################################


sub SauteResultatsMots{
 while ($LigneMots = <STATBYFILE>){
   if ($LigneMots  =~ /^<\/WORDS>/)
   {return ;
   }
 }
}

sub SauteResultatsMots{
 while ($LigneMots = <STATBYFILE>){
   if ($LigneMots  =~ /^<\/WORDS>/)
   {return ;
   }
 }
}

sub SauteResultatsTags{
 while ($LigneTags = <STATBYFILE>){
   if ($LigneTags =~ /^<\/TAGS>/)
   {return ;
   }
 }
}

sub SauteResultatsELEMENTS{
 while ($LigneTags = <STATBYFILE>){
   if ($LigneTags =~ /^<\/ELEMENTS>/)
   {return ;
   }
 }
}

sub SauteResultatsELEMENTS_ATTR{
 while ($LigneTags = <STATBYFILE>){
   if ($LigneTags =~ /^<\/ELEMENTS_ATTR>/)
   {return ;
   }
 }
}

sub SauteResultatsELEMENTS_ATTRVALUE{
 while ($LigneTags = <STATBYFILE>){
   if ($LigneTags =~ /^<\/ELEMENTS_ATTRVALUE>/)
   {return ;
   }
 }
}
sub ImprimeTrait2Frequence{
 open (CHOIX, ">$NomFichierChoixTraitsPourStatWordByFile2Matrice") ;
 if ($TriParFrequence == 1)
 {@TraitsTries = sort { $Trait2Frequence{$b} <=> $Trait2Frequence{$a} } keys %Trait2Frequence ;
 }
 else
 {@TraitsTries = sort keys %Trait2Frequence ;
 } 
 foreach $TraitCourant (@TraitsTries)
 {print CHOIX "$BaliseEntreChoixEtIndividuOuTrait$TraitCourant\t$Trait2Frequence{$TraitCourant}\n" ;
 }
 close(CHOIX) ;
}


sub MetAJourJournalMatrice{
    open(JOURNAL, ">>$NomFichierJournalMatrice") ;
    print JOURNAL "\n\n---------------\n$DateCourante\n\n" ;
    print JOURNAL "StatWordByFile2ChoixTraitsPourStatWordByFile2Matrice.pl \n\t\t-segmentation\t\t\t$opt_segmentation \n\t\t-all\t\t\t$opt_all  \n\t\t-words\t\t\t$opt_words  \n\t\t-tags\t\t\t$opt_tags  \n\t\t-elts\t\t\t$opt_elts  \n\t\t-attrs\t\t\t$opt_attrs  \n\t\t-attrvalues\t\t\t$opt_attrvalues  \n\t\t-entree\t\t\t$opt_entree\n\t\t-prefixe_sortie\t\t\t$opt_prefixe_sortie\n\t\t-tri\t\t\t$opt_tri\n\n" ;
    print JOURNAL "\nFichier de choix de traits pour StatWordByFile2Matrice.pl : $NomFichierChoixTraitsPourStatWordByFile2Matrice\n\nSi l'on veut laguer a priori la matrice issue de $opt_entree :\n1) Modifier  la main $NomFichierChoixTraitsPourStatWordByFile2Matrice en ajoutant en dbut de ligne O, o ou + devant les traits que l'on veut garder \n2) Appeler StatWordByFile2Matrice.pl avec les options souhaites pour les traits\n\tStatWordByFile2Matrice.pl -segmentation $opt_segmentation <options pour les traits> -entree $opt_entree -prefixe_sorties <prfixe sorties> -choix_traits $NomFichierChoixTraitsPourStatWordByFile2Matrice\n\n\n" ;
    close(JOURNAL) ;
}

