#!/usr/bin/perl
#  StatWordByFile2Matrice.pl

<<DOC; 
B. Habert
28/09/00

               StatWordByFile2Matrice.pl :


Format d'entre : 
Emploi : StatWordByFile2Matrice.pl -segmentation page|site [-all O|o] [-words O|o] [-tags O|o] [-elts O|o] [-attrs O|o] [-attrvalues O|o] -entree <sorties StatWordByFile> -prefixe_sorties <partie commune des fichiers rsultats> [-choix_traits <fichier de choix de traits>]

        3 couples mot-cl / valeur sont obligatoires :
        -segmentation page|site
        -entree <sorties StatWordByFile>
        -prefixe_sorties <partie commune des fichiers rsultats>

        On peut slectionner tous les traits souhaits et toutes les combinaisons. 
        Par ailleurs, si l'on fournit un <fichier de choix de traits> pour le mot-cl -choix_traits, en utilisant un fichier d'extension ".ChoixTraitsPourStatWordByFile2Matrice" engendr prcdemment par StatWordByFile2ChoixTraitsPourStatWordByFile2Matrice.pl et modifi  la main (avec O, o ou + en premire position pour les traits que l'on veut garder), la matrice engendre ne comprendra que les traits retenus.

	. Le fichier Matrices.Journal, pour chaque appel de StatWordByFile2Matrice.pl, mmorise la date, l'appel, ses couples mot-cl / valeur et les fichiers rsultats ainsi que les oprations possibles sur eux.
     

Exemples d'appel :


     Sorties produites par SF (StatWordByFile.txt), de la forme :

<TAGS>
<SITE>jura.speleo_new</SITE>
<PAGE>E:/sitesPPete99/jura.speleo_new/index.html</PAGE>
<ELEMENTS>
<ITEM>P</ITEM><FRQ>17</FRQ>
<ITEM>FONT</ITEM><FRQ>17</FRQ>
...
</ELEMENTS>
<ELEMENTS_ATTR>
<ITEM>FONT(COLOR)</ITEM><FRQ>10</FRQ>
<ITEM>FONT(FACE)</ITEM><FRQ>9</FRQ>
...
</ELEMENTS_ATTR>
<ELEMENTS_ATTRVALUE>
<ITEM>FONT(FACE=ARIAL)</ITEM><FRQ>7</FRQ>
<ITEM>IMG(ALIGN=BOTTOM)</ITEM><FRQ>4</FRQ>
...
</ELEMENTS_ATTRVALUE>
</TAGS>
<WORDS>
<SITE>jura.speleo_new</SITE>
<PAGE>E:/sitesPPete99/jura.speleo_new/index.html</PAGE>
<ITEM>le</ITEM><FRQ>4</FRQ>
<ITEM>et</ITEM><FRQ>3</FRQ>
...
</WORDS>


Format des sorties :
     Une matrice pour traitements statistiques, une correspondance noms / traits, un changeur noms -> traits, le profil des individus et le fichier pour indiquer les choix faits pour les individus, le profil des traits et le fichier pour indiquer les choix faits pour les traits (extensions : ".Matrice", ".Noms2Traits", ".ChangeNoms2Traits.pl", ".ProfilLignes", ".ChoixIndividus", ".ProfilColonnes", ".ChoixTraits").

  1) Une matrice (extension .Matrice) avec sur la premire ligne, aprs ID, les traits remplacs par des noms engendrs de 8 caractres (des identifieurs utilisant les 26 lettres de l'alphabet sur 6 positions, ce qui fait 308 915 776 possibilits, avec un caractre sparateur arbitraire en dbut et un autre en fin, pour faciliter le remplacement systmatique et rendre improbables les conflits de noms).
    Exemple de matrice :
ID	_aaaaab_	_aaaaac_	_aaaaad_	_aaaaae_
jura_speleo1	1146	6	153	1695
mairie_aureilhan1	47	1	0	213

    2) Une trace de la correspondance noms engendrs / traits originels (extension .Noms2Traits) 
    Exemple correspondant :
        _aaaaab_        A       _aaaaac_        ADDRESS _aaaaad_        AREA    _aaaaae_        B

    3) Un programme Perl excutable de remplacement des noms engendrs par les noms de traits originels (extension .ChangeNoms2Traits.pl).
    Exemple correspondant :
#!/usr/bin/perl
#Tue Oct  3 22:27:28 WEST 2000

#Engendr par LignesNomFichierCouplesFrequenceType2Matrice.pl
#pour JuraAureilhan.Matrice et les donnes qui sont calcules  partir de cette matrice

while(<>)
{
s/_aaaaab_/A/g ;
s/_aaaaac_/ADDRESS/g ;
s/_aaaaad_/AREA/g ;
s/_aaaaae_/B/g ;

print ;
}


Pour retrouver les traits  la place des noms engendrs. Exemple :
JuraAureilhan.ChangeNoms2Traits.pl < JuraAureilhan.Matrice > JuraAureilhan.MatriceCorrigee

A faire :

Bugs et problmes :
     Attention aux erreurs qui peuvent tre lies au passage de Windows  Linux en ce qui concerne la fin de ligne (\r\n versus \n). C'est la raison de l'optionalit de \r? dans la regexp infra.

Historique :
     12/10/00 Nouveau format fourni par Serge Fleury <TAGS> et </TAGS>, ainsi que <WORDS> et </WORDS> 
     14/10/00 Amlioration du format par Serge Fleury. 
    Par ailleurs :
         . ajout de nouvelles options pour pouvoir rcuprer mots et tags (-all) ou d'emble se limiter 
              - aux lments (-elts) ;
              - aux attributs (-attr) ; 
              - aux lments et aux attributs (-eltsattr) ; 
              - aux valeurs d'attributs (-attrvalue).
          Il semble que les valeurs d'attributs soient trs disperses et peu utilisables ( reclasser avant de crer la matrice). Par contre, il peut tre intressant de grouper lments et attributs, d'o l'option.
         . dans la sortie par page, introduction d'un sparateur entre le nom du site et la page (variable $SeparateurNomSiteNomPage, dont la valeur actuelle est une balise XML vide : <SITE2PAGE/>). Exemple : jura.speleo_new<SITE2PAGE/>E:/sitesPPete99/jura.speleo_new/index.html. Cette balise a pour fonction de permettre des tris manuels ultrieurs.
    02/01/01
         . Passage d'arguments positionnels  des arguments par mots-cls
         . Enregistrement sur un journal des entres/sorties
         . Limitation  un sous-ensemble de traits

DOC
use Getopt::Long ;

$ChaineUsage = "Usage : StatWordByFile2Matrice.pl -segmentation page|site [-all O|o] [-words O|o] [-tags O|o] [-elts O|o] [-attrs O|o] [-attrvalues O|o] -entree <sorties StatWordByFile> -prefixe_sorties <partie commune des fichiers rsultats> [-choix_traits <fichier de choix de traits>]\n" ;


@optl = ("segmentation=s", "all:s", "words:s", "tags:s", "elts:s", "attrs:s", "attrvalues:s", "entree=s", "prefixe_sorties=s", "choix_traits:s") ;

die $ChaineUsage  unless GetOptions @optl  ;


%Item2AGarderOuASupprimer                = () ;
$AGarder                                 = "O" ;
$ASupprimer                              = "N" ;
$BaliseEntreChoixEtIndividuOuTrait       = "<CHOIX/>" ;
$ChoixPositif                            = "[oO+]" ;
$ChoixNegatif                            = "[Nn-]" ;
$ExtensionChoixIndividus                 = ".ChoixIndividus" ;
$ExtensionChoixTraits                    = ".ChoixTraits" ;
#$DateCourante                 = `date` ;
$DateCourante                 = localtime ;
$NomFichierJournalMatrice     = "Matrices.Journal" ;
$NomFichierStatByFile         = $opt_entree || die $ChaineUsage  ;
$NomFichierMatriceTraits      = $opt_prefixe_sorties || die $ChaineUsage ;
$SegmentationChoisie          = $opt_segmentation || die $ChaineUsage ;
$ResultatsMots      = 0 ;
$ResultatsElts      = 0 ;
$ResultatsAttr      = 0 ;
$ResultatsAttrValue = 0 ;
$OptionChoisie                = "[Oo]" ;

if ($opt_choix_traits)
{if (-r $opt_choix_traits)
 {open(CHOIXITEMS, "<$opt_choix_traits") ;
  LitChoixTraits() ;
  close(CHOIXITEMS) ;  
 }
 else 
 {print STDERR "$opt_choix_traits Mauvais nom de fichier\n" ; die $ChaineUsage ; 
 }
}



if ($SegmentationChoisie eq "page") 
   {$PartieEgaleSite = 0 ;
   }
elsif ($SegmentationChoisie eq "site") 
   {$PartieEgaleSite = 1 ;
   }
else
   {print STDERR "$SegmentationChoisie Mauvaise valeur d'option\n" ; die $ChaineUsage ; }

if ($opt_all)
{if ($opt_all =~ /$OptionChoisie/)
 {$ResultatsMots      = 1 ;
  $ResultatsElts      = 1 ;
  $ResultatsAttr      = 1 ;
  $ResultatsAttrValue = 1 ;

 }
 else 
 {print STDERR "$opt_all Mauvaise valeur d'option\n" ; die $ChaineUsage ; 
 }
}
if ($opt_words)
{if ($opt_words =~ /$OptionChoisie/)
 {$ResultatsMots      = 1 ;
 }
 else 
 {print STDERR "$opt_words Mauvaise valeur d'option\n" ; die $ChaineUsage ; 
 }
}
if ($opt_tags)
{if ($opt_tags =~ /$OptionChoisie/)
 {$ResultatsElts      = 1 ;
  $ResultatsAttr      = 1 ;
  $ResultatsAttrValue = 1 ;

 }
 else 
 {print STDERR "$opt_tags Mauvaise valeur d'option\n" ; die $ChaineUsage ; 
 }
}
if ($opt_elts)
{if ($opt_elts =~ /$OptionChoisie/)
 {$ResultatsElts      = 1 ;
 }
 else 
 {print STDERR "$opt_eltsMauvaise valeur d'option\n" ; die $ChaineUsage ; 
 }
}
if ($opt_attrs)
{if ($opt_attrs =~ /$OptionChoisie/)
 {$ResultatsAttr      = 1 ;
 }
 else 
 {print STDERR "$opt_attrs Mauvaise valeur d'option\n" ; die $ChaineUsage ; 
 }
}
if ($opt_attrvalues)
{if ($opt_attrvalues =~ /$OptionChoisie/)
 {$ResultatsAttrValue = 1 ;
 }
 else 
 {print STDERR "$opt_attrvalues Mauvaise valeur d'option\n" ; die $ChaineUsage ; 
 }
}

$SuffixeNoms2Traits                              = ".Noms2Traits" ;
$NomFichierNoms2Traits                           = $NomFichierMatriceTraits . $SuffixeNoms2Traits ;
$NomFichierLignesTemporaire                      = "StatWordByFile2Matrice.tmp" ;
%Trait2Frequence                                 = () ;
$NumeroBilanPartiel                              = 0 ;
$AncienNomSite                                   = "" ;                 
$AncienNomPage                                   = "" ;      
$NomSite                                         = "" ;                 
$NomPage                                         = "" ;      
$PartieEgaleSite                                 = 1  ;
$SeparateurNomSiteNomPage                        = "<SITE2PAGE/>" ;
$NumeroPartieTag                                 = 0 ;


open(STATBYFILE, "<$NomFichierStatByFile") ;
open(LIGNES, ">$NomFichierLignesTemporaire") ;

while ($Ligne = <STATBYFILE>){
  if ($Ligne =~ /^<WORDS>/)
  {if ($ResultatsMots == 0)
   {SauteResultatsMots() ;
   }
  }
  elsif ($Ligne =~ /^<TAGS>/)
  {if ($ResultatsElts == 0 && $ResultatsAttr == 0 && $ResultatsAttrValue == 0)
   {SauteResultatsTags() ;
   }
  }
  elsif ($Ligne =~ /^<ELEMENTS>/ && $ResultatsElts == 0)
   {SauteResultatsELEMENTS() ;
   }
  elsif ($Ligne =~ /^<ELEMENTS_ATTR>/ && $ResultatsAttr == 0)
   {SauteResultatsELEMENTS_ATTR() ;
   }
  elsif ($Ligne =~ /^<ELEMENTS_ATTRVALUE>/ && $ResultatsAttrValue == 0)
   {SauteResultatsELEMENTS_ATTRVALUE() ;
   }
  elsif ($Ligne =~ /^<SITE>(.+)<\/SITE>/)
  {$AncienNomSite       = $NomSite ;
   $NomSite             = $1 ;
  }
  elsif ($Ligne =~ /^<PAGE>(.+)<\/PAGE>/)
  {$AncienNomPage       = $NomPage ;
   $NomPage             = $1 ;

#   print $Ligne ;
   print "$NomSite\t$NomPage\n" ;
   ImprimeEventuellementBilanPartie() ;
   $NumeroBilanPartiel++ ;
  }
  elsif ($Ligne =~ /^<ITEM>(.+)<\/ITEM><FRQ>(\d+)<\/FRQ>/)
  {$Trait          = $1 ;
   $Frequence      = $2 ;
   if (exists $Item2AGarderOuASupprimer{$Trait})
   {# print "$Trait\t$Item2AGarderOuASupprimer{$Trait}\n" ;
    if ($Item2AGarderOuASupprimer{$Trait} =~ /$AGarder/)
     {EngrangeAssociationTraitFrequence() ;
     }
   }
   elsif (!$opt_choix_traits)
   {EngrangeAssociationTraitFrequence() ;
   }
  }
}
close(STATBYFILE) ;
ImprimeDernierePartie() ;
close(LIGNES) ;
 

# system("mv", "StatWordByFile2Matrice.tmp", "$NomFichierMatriceTraits");
 rename "StatWordByFile2Matrice.tmp", "$NomFichierMatriceTraits" ;
# system("./LignesNomFichierCouplesFrequenceType2Matrice.pl", "$NomFichierMatriceTraits") ;
 system("perl LignesNomFichierCouplesFrequenceType2Matrice.pl $NomFichierMatriceTraits") ;
#  system("rm", "$NomFichierMatriceTraits") ;
 unlink $NomFichierMatriceTraits  ;
# system("./FournitProfilColonnesLignesMatrice.pl", "$NomFichierMatriceTraits") ;
 system("perl FournitProfilColonnesLignesMatrice.pl $NomFichierMatriceTraits") ;
 print STDERR "\n\nPartie commune des rsultats : $NomFichierMatriceTraits\n\tMatrice : $NomFichierMatriceTraits.Matrice\n\tCorrespondance noms engendrs / traits de dpart : $NomFichierMatriceTraits.Noms2Traits\n\tInverseur des noms engendrs vers les traits de dpart : $NomFichierMatriceTraits.ChangeNoms2Traits.pl\n\tProfil des individus : $NomFichierMatriceTraits.ProfilLignes et choix faits : $NomFichierMatriceTraits.ChoixIndividus\n\tProfil des traits : $NomFichierMatriceTraits.ProfilColonnes et choix faits : $NomFichierMatriceTraits.ChoixTraits\n\nSi l'on veut laguer la matrice rsultant~:\n1) Modifier  la main $NomFichierMatriceTraits.ChoixIndividus et/ou $NomFichierMatriceTraits.ChoixTraits \n2) Appeler EmondeProfilMatrice.pl -type individus -partie_commune $NomFichierMatriceTraits  <seuils et plafonds choisis> et/ou EmondeProfilMatrice.pl -type traits -partie_commune $NomFichierMatriceTraits <seuils et plafonds choisis>\n3) Appeler ElimineColonnesLignesDeMatrice.pl $NomFichierMatriceTraits.Matrice $NomFichierMatriceTraits.ProfilColonnes[.Emondage] $NomFichierMatriceTraits.ProfilLignes[.Emondage]\n" ;
MetAJourJournalMatrice() ;

    

################### Routines #################################

sub EngrangeAssociationTraitFrequence{
   if (exists $Trait2Frequence{$Trait})
   {$Trait2Frequence{$Trait} += $Frequence ;
   }
   else
   {$Trait2Frequence{$Trait} = $Frequence ;
   }   
}

sub SauteResultatsMots{
 while ($LigneMots = <STATBYFILE>){
   if ($LigneMots  =~ /^<\/WORDS>/)
   {return ;
   }
 }
}

sub SauteResultatsMots{
 while ($LigneMots = <STATBYFILE>){
   if ($LigneMots  =~ /^<\/WORDS>/)
   {return ;
   }
 }
}

sub SauteResultatsTags{
 while ($LigneTags = <STATBYFILE>){
   if ($LigneTags =~ /^<\/TAGS>/)
   {return ;
   }
 }
}

sub SauteResultatsELEMENTS{
 while ($LigneTags = <STATBYFILE>){
   if ($LigneTags =~ /^<\/ELEMENTS>/)
   {return ;
   }
 }
}

sub SauteResultatsELEMENTS_ATTR{
 while ($LigneTags = <STATBYFILE>){
   if ($LigneTags =~ /^<\/ELEMENTS_ATTR>/)
   {return ;
   }
 }
}

sub SauteResultatsELEMENTS_ATTRVALUE{
 while ($LigneTags = <STATBYFILE>){
   if ($LigneTags =~ /^<\/ELEMENTS_ATTRVALUE>/)
   {return ;
   }
 }
}

sub ImprimeTrait2Frequence{
 foreach $TraitCourant (keys %Trait2Frequence)
 {print "$TraitCourant $Trait2Frequence{$TraitCourant}\t" ;
 }
 print "\n" ;
}

sub ImprimeEventuellementBilanPartie{
 if ($NumeroBilanPartiel > 0)
 {if ($PartieEgaleSite  == 0)
  {if ($AncienNomSite eq $NomSite 
       && $AncienNomPage ne $NomPage )
   {$NomPartie = $AncienNomSite . $SeparateurNomSiteNomPage . $AncienNomPage ;
    ImprimeBilanPartie() ;
    %Trait2Frequence                                 = () ;
   }
  }
  else
  {if ($AncienNomSite ne $NomSite)
    {$NomPartie = $AncienNomSite ;
     ImprimeBilanPartie() ;
     %Trait2Frequence                                 = () ;
    }
  }
 }
}

sub ImprimeDernierePartie{
  if ($PartieEgaleSite  == 0)
  {$NomPartie = $NomSite . $SeparateurNomSiteNomPage . $NomPage ; 
  }
  else
  {$NomPartie = $NomSite ;
  }
  ImprimeBilanPartie() ;
}

sub ImprimeBilanPartie{
 print LIGNES "$NomPartie" ;
 foreach $TraitCourant (keys %Trait2Frequence)
 {print LIGNES "\t$Trait2Frequence{$TraitCourant}\t$TraitCourant" ;
 }
 print LIGNES "\n" ;
}

sub MetAJourJournalMatrice{
    open(JOURNAL, ">>$NomFichierJournalMatrice") ;
    print JOURNAL "\n\n---------------\n$DateCourante\n\n" ;
    print JOURNAL "StatWordByFile2Matrice.pl \n\t\t-segmentation\t\t\t$opt_segmentation \n\t\t-all\t\t\t$opt_all  \n\t\t-words\t\t\t$opt_words  \n\t\t-tags\t\t\t$opt_tags  \n\t\t-elts\t\t\t$opt_elts  \n\t\t-attrs\t\t\t$opt_attrs  \n\t\t-attrvalues\t\t\t$opt_attrvalues  \n\t\t-entree\t\t\t$opt_entree  \n\t\t-prefixe_sorties\t\t\t$opt_prefixe_sorties  \n\t\t-choix_traits\t\t\t$opt_choix_traits\n\n" ;
    print JOURNAL "\nPartie commune des rsultats : $NomFichierMatriceTraits\n\tMatrice : $NomFichierMatriceTraits.Matrice\n\tCorrespondance noms engendrs / traits de dpart : $NomFichierMatriceTraits.Noms2Traits\n\tInverseur des noms engendrs vers les traits de dpart : $NomFichierMatriceTraits.ChangeNoms2Traits.pl\n\tProfil des individus : $NomFichierMatriceTraits.ProfilLignes et choix faits : $NomFichierMatriceTraits.ChoixIndividus\n\tProfil des traits : $NomFichierMatriceTraits.ProfilColonnes et choix faits : $NomFichierMatriceTraits.ChoixTraits\n\nSi l'on veut laguer la matrice rsultant~:\n1) Modifier  la main $NomFichierMatriceTraits.ChoixIndividus et/ou $NomFichierMatriceTraits.ChoixTraits \n2) Appeler EmondeProfilMatrice.pl -type individus -partie_commune $NomFichierMatriceTraits <seuils et plafonds choisis> et/ou EmondeProfilMatrice.pl -type traits -partie_commune $NomFichierMatriceTraits <seuils et plafonds choisis>\n3) Appeler ElimineColonnesLignesDeMatrice.pl $NomFichierMatriceTraits.Matrice $NomFichierMatriceTraits.ProfilColonnes[.Emondage] $NomFichierMatriceTraits.ProfilLignes[.Emondage]\n" ;
    close(JOURNAL) ;
}

sub LitChoixTraits{
  while ($LigneChoix = <CHOIXITEMS>){
#      print $LigneChoix ;
  if ($LigneChoix =~ /^$ChoixPositif$BaliseEntreChoixEtIndividuOuTrait([^\t]+)\t(.+)/)
      {$Trait = $1 ;
       $Item2AGarderOuASupprimer{$Trait} = $AGarder ;
#       print "A garder $Trait\n" ;
   }
  elsif ($LigneChoix =~ /^$ChoixNegatif$BaliseEntreChoixEtIndividuOuTrait([^\t]+)\t(.+)/)
      {$Trait = $1 ;
       $Item2AGarderOuASupprimer{$Trait} = $ASupprimer ;
   }
 }
}
